$	old_verify = f$verify('f$trnlnm("WATCH_INT_MP$VERIFY")'+0)
$!
$! WATCH_INT_MP.COM
$!
$! Watch CPU interrupt-state and Multiprocessor Synchronization time
$! on an SMP system
$!
$! Modification history:
$!	Based on WATCH_INT             K.Parris  10/08/2003
$!
$! Author: Keith Parris  parris@encompasserve.org or keithparris@yahoo.com
$!                       or keith.parris@hp.com
$! http://www.geocities.com/keithparris/ or http://encompasserve.org/~parris/
$! or http://www2.openvms.org/kparris/
$!
$! Define threshold percentages at which we start becoming concerned and alarmed
$!
$ int_yellow_threshold = 50	!Start to be concerned when it gets above 50%
$ int_red_threshold = 70	!Really worry when it gets above 70%
$ mp_yellow_threshold = 25	!Start to be concerned when it gets above 20%
$ mp_red_threshold = 40		!Really worry when it gets above 30%
$!
$	blink = "FALSE"	!"TRUE"	!Enable/Disable blinking
$!
$! Set width of bar graphs
$	fullscale = 10	!Number of columns for full scale
$	halfscale = fullscale/2	!Number of columns for half scale (for rounding)
$!
$! $MONITOR utility /INTERVAL value in units of seconds
$!	mon_interval = 60	!or 60 seconds
$!!	mon_interval = 10	!!!or 10 seconds for testing
$!	mon_interval = 3		!!!or 3 seconds for quicker samples
$	mon_interval = 1		!!!or 1 second for even quicker samples
$! Length of time between taking each set of samples
$!	inter_sample_time = "00:00:10"	!~10 seconds between checks (plus time in $MONITOR)
$!!	inter_sample_time = "00:01:00"	!~1 minute between checks (plus time in $MONITOR)
$!!	inter_sample_time = "00:00:20"	!~30 seconds between checks
$!	inter_sample_time = "00:00:10"	!~20 seconds between checks
$!	inter_sample_time = "00:00:7"	!~10 seconds between checks
$	inter_sample_time = "00:00:1"	!~5 seconds between checks
$!
$!----------------------------------------------------------------------------
$!
$! Start by defining symbols for the escape sequences we'll need to display
$! things.
$!
$ ESC[0,8]=27
$ CSI[0,8]=155
$ DCS[0,8]=144
$! Reset graphics rendition
$ SGR_RESET = CSI + "0m"
$! Bold, Blink, Underline, Reverse Video
$ SGR_BOLD = CSI + "1m"
$ SGR_UNDERLINE = CSI + "4m"
$ SGR_BLINK = CSI + "5m"
$ SGR_REVERSE = CSI + "7m"
$ SGR_BOLD_OFF = CSI + "22m"
$ SGR_UNDERLINE_OFF = CSI + "24m"
$ SGR_BLINK_OFF = CSI + "25m"
$ SGR_REVERSE_OFF = CSI + "27m"
$! Foreground color
$ SGR_FG_Black = CSI + "30m"
$ SGR_FG_Red = CSI + "31m"
$ SGR_FG_Green = CSI + "32m"
$ SGR_FG_Yellow = CSI + "33m"
$ SGR_FG_Blue = CSI + "34m"
$ SGR_FG_Magenta = CSI + "35m"
$ SGR_FG_Cyan = CSI + "36m"
$ SGR_FG_White = CSI + "37m"
$ SGR_FG_DEFAULT = CSI + "39m"
$! Background color
$ SGR_BG_Black = CSI + "40m"
$ SGR_BG_Red = CSI + "41m"
$ SGR_BG_Green = CSI + "42m"
$ SGR_BG_Yellow = CSI + "43m"
$ SGR_BG_Blue = CSI + "44m"
$ SGR_BG_Magenta = CSI + "45m"
$ SGR_BG_Cyan = CSI + "46m"
$ SGR_BG_White = CSI + "47m"
$ SGR_BG_DEFAULT = CSI + "49m"
$ SGR_RESET_COLOR = SGR_FG_DEFAULT + SGR_BG_DEFAULT
$!
$ ED_ALL = CSI + "2J"	!Erase display, all of it
$ ED_EOS = CSI + "J"	!Erase display, from cursor to end of screen
$ EL_EOL = CSI + "K"	!Erase from cursor position to end of line
$ HOME = CSI + "H"
$ LD_ON = ESC + "(0"	!LINE_DRAWING_ON
$ LD_OFF = ESC + "(B"	!LINE_DRAWING_OFF
$! SE_CORNER = "''LD_ON'j''LD_OFF'"
$! NE_CORNER = "''LD_ON'k''LD_OFF'"
$! NW_CORNER = "''LD_ON'l''LD_OFF'"
$! SW_CORNER = "''LD_ON'm''LD_OFF'"
$! CROSS = "''LD_ON'n''LD_OFF'"
$! SCAN1 = "''LD_ON'o''LD_OFF'"
$! SCAN3 = "''LD_ON'p''LD_OFF'"
$! SCAN5 = "''LD_ON'q''LD_OFF'"
$! HORIZ_LINE = SCAN5
$! SCAN7 = "''LD_ON'r''LD_OFF'"
$! SCAN9 = "''LD_ON's''LD_OFF'"
$! S1 = "o"
$! S3 = "p"
$! S5 = "q"
$! S7 = "r"
$! S9 = "s"
$! W_TEE = "''LD_ON't''LD_OFF'"
$! E_TEE = "''LD_ON'u''LD_OFF'"
$! S_TEE = "''LD_ON'v''LD_OFF'"
$! N_TEE = "''LD_ON'w''LD_OFF'"
$ VL = "x"
$ VERT_LINE = LD_ON + VL + LD_OFF
$! SPACE = "''LD_ON'_''LD_OFF'"
$ SP = " "
$! DOT = "''LD_ON'~''LD_OFF'"
$!-----------------------
$ wo :== write sys$output
$ clr = "''wo' ED_ALL"
$! clr
$! End of escape-sequence setup work.
$!
$	delete := delete
$	pid = f$getjpi("","PID")
$	temp_file := watch_int_mp_temp_'pid'.temp_file
$!
$	node = f$getsyi("NODENAME")
$	write sys$output "Watch_Int_MP is running on node ",node
$	heading_printed = "FALSE"
$!
$ on control_y then goto CLEANUP
$!
$! Main program loop
$!
$	default_sample_length = "150"
$	sampling_failure_count = 0
$ loop:
$	sample_length = default_sample_length
$	retry_count = 0
$!
$ do_monitor:
$! set noon	!Catch occasional error of:
$ on error then goto catch_monitor_error
$! %MONITOR-E-UNEXPERR, unexpected error
$! -MONITOR-E-INSCOLL, not enough collections for summary processing
$!! write sys$output "Calling $MONITOR with sample_length = ",sample_length  !@!
$	sample_secs = sample_length / 100
$	sample_centi = f$fao("!2ZL",sample_length - (sample_secs * 100))
$! write sys$output "Calling $MONITOR with sample_length = ",sample_secs,".",sample_centi  !@!
$!	define/user sys$output _nla0:
$	monitor modes/cpu=(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,-
		16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31) -
-!!!!		/node=(f20ws1,f20ws2,f20ws3) -
		/interval='mon_interval' /current -
		/ending="+0:0:''sample_secs'.''sample_centi'" -
		/nodisplay/summary='temp_file'
$! write sys$output "Monitor data collection successful"	!@!
$	goto got_monitor_data
$catch_monitor_error:
$!At this point, the deafult "on error then exit" condition has been reinstated
$	status = $status
$	severity = $severity
$! show symbol severity	!@!
$! show symbol status	!@!
$!@! write sys$output -						!@!
$!_@!" ** Monitor data collection failed. ",-			!@!
$!_@!				" $SEVERITY = ",severity,-	!@!
$!_@!				" $STATUS = ",status		!@!
$! If for some reason we didn't pick up the summary, report the error
$	if status .eq. %X10CE81FA
$	then
$		write sys$output "MONITOR data-collection sampling error.  Retrying."
$		wait 0:0:0.10	!Avoid infinite loops
$		retry_count = retry_count + 1
$		if retry_count .eq. 1
$		then
$		    sampling_failure_count = sampling_failure_count + 1
$		    if sampling_failure_count .ge. 5
$		    then	!Raise default interval 1/2 second
$			default_sample_length = default_sample_length + 50
$			sampling_failure_count = 0
$		    endif
$		endif
$		sample_length = sample_length + 50	!Wait .5 second longer	!@!
$		goto do_monitor
$	endif
$	if severity .ne. 1
$	then
$		write sys$output "MONITOR error: "
$		write sys$output "  $Severity was ",severity
$		write sys$output "  $Status was ",status
$		write sys$output "  Message: ",f$message(status)
$		wait 0:0:1	!Avoid infinite loops
$	endif
$!@!	sample_length = "3.0"	!@!
$	goto do_monitor
$got_monitor_data:
$	on error then exit	!Restore default "ON" condition
$!!! type/page 'temp_file'	!!!
$	search/out='temp_file'_1 'temp_file' -
		"on node ",-
		"CPU ID ",-
		"Interrupt Sta",-	!te" for Alpha, ck" for VAX
		"MP Synchronization"
$	severity = $severity
$	delete 'temp_file';*
$	if severity .eq. 3
$	then
$		write sys$output "Monitor summary file empty.  Retrying."
$		wait 0:0:0.10	!Avoid infinite loops
$		goto do_monitor	!MONITOR must have failed.  Try again.
$	endif
$! type 'temp_file'_1	!!!
$	close/nolog temp1
$	open/read temp1 'temp_file'_1
$	read temp1 rec	!Read timestamp rec
$	rec = f$edit(rec,"COMPRESS,TRIM")
$! show symbol rec	!!!
$	time = f$element(8," ",rec)
$! show symbol time	!!!
$!	cpu_cnt = 0
$	line = time		!+ " "
$!  Time  |Int MP CPU 1     |Int MP CPU 2     |Int MP CPU 3     
$!12:38:21| 17  0 II11111111|  0  3 2222222222|  0 10 M333333333
$	if .not. heading_printed then hdg = "  Time  "
$ CPU_LOOP:
$!!!!	read/end=CPU_EOF temp1 rec
$!!!!	rec = f$edit(rec,"COMPRESS,TRIM")
$!!!! show symbol rec	!!!
$!!!!	node = f$element(2," ",rec)
$!!!! show symbol node		!!!
$	read/end=CPU_EOF temp1 rec
$	rec = f$edit(rec,"COMPRESS,TRIM")
$! show symbol rec	!!!
$	cpu = f$element(2," ",rec)
$! show symbol cpu	!!!
$	if .not. heading_printed then -
		hdg = hdg + "|Int MP CPU " + -
			f$extract(0,6,f$fao("!UL",'cpu')+"     ")
$	read temp1/end=CPU_EOF rec
$	rec = f$edit(rec,"COMPRESS,TRIM")
$! show symbol rec	!!!
$	int = f$integer(f$element(2," ",rec))	!% interrupt stack/state CPU
$! show symbol int		!!!
$	read/end=CPU_EOF temp1 rec
$	rec = f$edit(rec,"COMPRESS,TRIM")
$! show symbol rec	!!!
$	mp = f$integer(f$element(2," ",rec))	!% MP Synch CPU
$! show symbol mp		!!!
$!!	call report_value
$!	int_'cpu' = int
$!	mp_'cpu' = mp
$!	cpu_cnt = cpu_cnt + 1
$	cpuid = cpu
$! show symbol cpu	!!!
$ cpuid_loop:
$	cpuid = cpuid + cpu
$	if f$length(cpuid) .lt. fullscale then goto cpuid_loop
$! show symbol cpuid	!!!
$	mp_digits = (mp + halfscale) / fullscale
$! show symbol mp_digits	!!!
$	int_digits = (int + halfscale) / fullscale
$! show symbol int_digits	!!!
$!
$	int_color = SGR_BG_Green + SGR_FG_Blue
$	if int .gt. int_yellow_threshold then int_color = -
			SGR_BG_Yellow + SGR_FG_Black
$	if int .gt. int_red_threshold
$	then
$		int_color = SGR_BG_Red + SGR_FG_Yellow
$		if blink then int_color = int_color + SGR_BLINK
$	endif
$	mp_color = SGR_BG_Green + SGR_FG_Blue
$	if mp .gt. mp_yellow_threshold then mp_color = -
			SGR_BG_Yellow + SGR_FG_Black
$	if mp .gt. mp_red_threshold
$	then
$		mp_color = SGR_BG_Red + SGR_FG_Yellow + SGR_BLINK
$		if blink then mp_color = mp_color + SGR_BLINK
$	endif
$	mp_chars = mp_color + f$extract(0,mp_digits,"MMMMMMMMMM")
$	int_chars = int_color + f$extract(0,int_digits,"IIIIIIIIII")
$	if blink 
$	then
$		mp_chars = mp_chars + SGR_Blink_OFF
$		int_chars = int_chars + SGR_Blink_OFF
$	endif
$!
$	other_digits = fullscale - int_digits - mp_digits
$! show symbol other_digits	!!!
$! Show readings themselves, too
$	int_reading = int_color + f$fao("!3UL",int)
$	mp_reading = mp_color + f$fao("!3UL",mp)
$	line = line + "|" + int_reading + mp_reading + SGR_RESET + " "
$	if int_digits .gt. 0 then line = line + int_chars
$	if mp_digits .gt. 0 then line = line + mp_chars
$	line = line + SGR_RESET
$	if other_digits .gt. 0 then line = line + f$extract(0,other_digits,cpuid)
$!
$	line = line
$	read temp1/end=CPU_EOF rec	!Throw away timestamp rec
$! show symbol rec	!!!
$	goto CPU_LOOP
$ CPU_EOF:
$	close temp1
$	if .not. heading_printed
$	then
$		write/symbol sys$output hdg
$		heading_printed = "TRUE"
$	endif
$	write/symbol sys$output line
$!
$	delete 'temp_file'_1;*
$!
$	wait 'inter_sample_time'	!Wait between checks
$!
$	goto loop
$!
$ CLEANUP:
$	wo SGR_RESET
$	close/nolog temp1
$	if f$search(temp_file) .nes. "" then delete 'temp_file';*
$	if f$search("''temp_file'_1") .nes. "" then delete 'temp_file'_1;*
$ EXIT:
$	exit 1+0*f$verify(old_verify)

$!
$! Report current value
$!
$ report_value: subroutine
$! show symbol cpu		!!!
$! show symbol int		!!!
$! show symbol mp		!!!
$! write sys$output ""		!!!
$! write sys$output "CPU ''cpu'"	!!!!, time ''f$time()'"
$!	write sys$output "  Interrupt state utilization: ''int'%"
$!	write sys$output "  MP Synch utilization: ''mp'%"
$	write sys$output "CPU ''cpu', IntSt ''int'%, MP ''mp'%"
$!
$	endsubroutine

! Output from $MONITOR MODES/CPU=0:

                            OpenVMS Monitor Utility
            +-----+         TIME IN PROCESSOR MODES
            | CUR |              on node HOSEA        From: 27-MAY-1997 13:49:02
            +-----+                 SUMMARY           To:   27-MAY-1997 13:52:02

CPU ID  0                            0         25        50        75       100
                                     + - - - - + - - - - + - - - - + - - - - -+
 Interrupt Stack                  15 |******
                                     |         |         |         |          |
 MP Synchronization                1 |
